SystemOrganization addCategory: #'OCMSTest-Kernel'!

Object subclass: #NameOfSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

TestCase subclass: #CommentTest
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CommentTest commentStamp: 'HAS 4/30/2013 20:13' prior: 0!
I test the class Comment!

!CommentTest methodsFor: 'initialize-release' stamp: 'HAS 4/30/2013 20:14'!
setUp

	comment := Comment new.! !

!CommentTest methodsFor: 'initialize-release' stamp: 'oda 5/13/2013 03:21'!
testAsDateAndTime
	| aDateAndTime |
	aDateAndTime := DateAndTime now.
	comment dateAndTime: aDateAndTime.
	
	self assert: comment dateAndTime = aDateAndTime.! !

!CommentTest methodsFor: 'initialize-release' stamp: 'HAS 4/30/2013 20:18'!
testAsText

	comment text: 'This is a comment regarding the courseware'.
	
	self assert: comment text = 'This is a comment regarding the courseware'.! !

!CommentTest methodsFor: 'initialize-release' stamp: 'HAS 4/30/2013 20:20'!
testAsUser
	
	"need to change this test"
	
	comment user: 'user'.
	
	self assert: comment user = 'user'.! !

TestCase subclass: #CoursewareManagerTest
	instanceVariableNames: 'coursewareManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CoursewareManagerTest commentStamp: 'HAS 4/30/2013 20:13' prior: 0!
I test the class CoursewareManagement!

!CoursewareManagerTest methodsFor: 'initialize-release' stamp: 'HAS 4/29/2013 20:02'!
setUp
	coursewareManager := CoursewareManager new.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 18:09'!
testAsBlockCoursewareNormal

	| coursewareTemp |

	coursewareTemp := Courseware new.
	coursewareManager courseware: (coursewareManager blockCourseware: coursewareTemp user: 'user').

	self assert: coursewareManager courseware enabled = false.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/29/2013 20:06'!
testAsGetMaxCoursewareId
	
	self assert: coursewareManager getMaxCoursewareId = 10.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 23:49'!
testAsIncludeCommentNormal

	| commentTemp |

	commentTemp := Comment new.
	commentTemp user: 'user'. "put an user here"
	commentTemp dateAndTime: DateAndTime now.
	commentTemp text: 'This is a comment about the courseware'.

	coursewareManager courseware: Courseware new.
	coursewareManager includeComment: coursewareManager courseware comment: commentTemp.

	self assert: coursewareManager courseware comment size = 1.
	self assert: (coursewareManager courseware comment at:1) text = 'This is a comment about the courseware'.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 16:12'!
testAsIncludeCoursewareNormal
	
	| aTag aListTag aListAuthor |
	
	aTag := Tag new.
	aTag name: 'CoursewareTag'.
	aListTag := OrderedCollection new.
	aListTag add: aTag.
	
	aListAuthor := OrderedCollection new.
	aListAuthor add: 'Author 1'; add: 'Author 2'.
	
	coursewareManager includeCourseware: 'First courseware' description: 'Description of the courseware' summary: 'Summary of the courseware' coursewareType: #Slide reference: 'http://reference.com' owner: 'User' tag: aListTag classification: 'Discipline C' author: aListAuthor cataloguingData: 'Catalog information' license: 'CC-CreativeCommons' size: 263.5 permission: nil file: 'Slide1.pdf'.

	self assert: coursewareManager courseware title = 'First courseware'.
	self assert: coursewareManager courseware description = 'Description of the courseware'.
	self assert: coursewareManager courseware summary = 'Summary of the courseware'.
	self assert: coursewareManager courseware coursewareType = #Slide.
	self assert: coursewareManager courseware reference = 'http://reference.com'.
	self assert: coursewareManager courseware owner = 'User'.
	self assert: coursewareManager courseware tag = aListTag.
	self assert: coursewareManager courseware classification = 'Discipline C'.
	self assert: coursewareManager courseware author = aListAuthor.
	self assert: coursewareManager courseware cataloguingData = 'Catalog information'.
	self assert: coursewareManager courseware license = 'CC-CreativeCommons'.
	self assert: coursewareManager courseware size = 263.5.
	self assert: coursewareManager courseware comment = nil.
	self assert: coursewareManager courseware score = nil.
	self assert: coursewareManager courseware permission = nil.
	self assert: coursewareManager courseware enabled = true.
	self assert: coursewareManager courseware downloadCounter = 0.
	self assert: coursewareManager courseware file = 'Slide1.pdf'.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 16:43'!
testAsIncludeCoursewareScoreNormal

	| scoreTemp coursewareTemp |

	scoreTemp := Dictionary new.
	scoreTemp at: 'user' put: 2.5.
	coursewareTemp := Courseware new.
	coursewareTemp score: scoreTemp.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdateCoursewareScore: coursewareManager courseware user: 'novo' score: 3.1.

	self assert: coursewareManager courseware score size = 2.
	self assert: (coursewareManager courseware score at: 'user') = 2.5.
	self assert: (coursewareManager courseware score at: 'novo') = 3.1.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 16:44'!
testAsIncludeOrUpdateCoursewareScoreNormal

	| scoreTemp coursewareTemp |

	scoreTemp := Dictionary new.
	scoreTemp at: 'user' put: 2.5.
	coursewareTemp := Courseware new.
	coursewareTemp score: scoreTemp.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdateCoursewareScore: coursewareManager courseware user: 'novo' score: 3.1.

	self assert: coursewareManager courseware score size = 2.
	self assert: (coursewareManager courseware score at: 'user') = 2.5.
	self assert: (coursewareManager courseware score at: 'novo') = 3.1.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 16:44'!
testAsIncludeOrUpdateCoursewareScoreNormalUpdatingScore

	| scoreTemp coursewareTemp |

	scoreTemp := Dictionary new.
	scoreTemp at: 'user' put: 2.5.
	coursewareTemp := Courseware new.
	coursewareTemp score: scoreTemp.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdateCoursewareScore: coursewareManager courseware user: 'user' score: 5.0.

	self assert: coursewareManager courseware score size = 1.
	self assert: (coursewareManager courseware score at: 'user') = 5.0.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 19:57'!
testAsIncludeOrUpdatePermissionErrorWrongPermission

	| coursewareTemp |

	coursewareTemp := Courseware new.
	coursewareManager courseware: coursewareTemp.
	
	self should: [coursewareManager includeOrUpdatePermission: coursewareManager courseware user: 'user' permission: #ReadWrite] raise: Error! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 19:58'!
testAsIncludeOrUpdatePermissionNormalIncludeAndUpdateUser

	| permissionTemp coursewareTemp |

	permissionTemp := Dictionary new.
	permissionTemp at: 'user' put: #Read.
	coursewareTemp := Courseware new.
	coursewareTemp permission: permissionTemp.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdatePermission: coursewareManager courseware user: 'user' permission: #ReadAndWrite.
	coursewareManager includeOrUpdatePermission: coursewareManager courseware user: 'admin' permission: #ReadAndWrite.

	self assert: coursewareManager courseware permission size = 2.
	self assert: (coursewareManager courseware permission at: 'user') = #ReadAndWrite.
	self assert: (coursewareManager courseware permission at: 'admin') = #ReadAndWrite.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 20:00'!
testAsIncludeOrUpdatePermissionNormalIncludeUser

	| coursewareTemp |

	coursewareTemp := Courseware new.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdatePermission: coursewareManager courseware user: 'user' permission: #Read.

	self assert: coursewareManager courseware permission size = 1.
	self assert: (coursewareManager courseware permission at: 'user') = #Read.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/29/2013 20:08'!
testAsIncrementCoursewareId
	
	self assert: coursewareManager incrementCoursewareId = 11.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 17:11'!
testAsIncrementDownloadCounterNormal

	| coursewareTemp |

	coursewareTemp := Courseware new.
	coursewareManager courseware: (coursewareManager incrementDownloadCounter: coursewareTemp).

	self assert: coursewareManager courseware downloadCounter = 1.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 18:10'!
testAsUnblockCoursewareNormal

	| coursewareTemp |

	coursewareTemp := Courseware new.
	coursewareTemp enabled: false.
	coursewareManager courseware: (coursewareManager unblockCourseware: coursewareTemp user: 'user').

	self assert: coursewareManager courseware enabled = true.! !

TestCase subclass: #CoursewareTest
	instanceVariableNames: 'courseware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CoursewareTest commentStamp: 'HAS 4/28/2013 17:53' prior: 0!
This class contains some tests about the class Courseware!

!CoursewareTest methodsFor: 'initialize-release' stamp: 'HAS 4/28/2013 18:00'!
setUp
	courseware := Courseware new.! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:16'!
testAsCoursewareTypeCorrect
	courseware coursewareType: #Audio.
	self assert: courseware coursewareType = #Audio! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:23'!
testAsCoursewareTypeWrong
	self should: [courseware coursewareType: #None] raise: Error! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:31'!
testAsId
	courseware id: 123.
	self assert: courseware id = 123! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:39'!
testAsIdDifferentType
	self should:[courseware id: '123'] raise: Error! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:11'!
testAsTitle
	courseware title: 'Courseware Title'.
	self assert: courseware title = 'Courseware Title'! !

TestCase subclass: #OCMSNoticationManagerTest
	instanceVariableNames: 'notificationManager professor student normalNotification systemNotification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!OCMSNoticationManagerTest methodsFor: 'setUp' stamp: 'oda 5/13/2013 03:54'!
setUp
	"Setups a empty notification manager, users, a normal Notification and a System notification"
	notificationManager := OCMSNotificationManager new.
	professor := User new isEnabled: true;
		name: 'Professor';
		email: 'professor@test.com';
		login: 'professor';
		password: 'professor'.
							
	student := User new name: 'Student';
		email: 'student@test.com';
		login: 'student';
		password: 'student'.
				
	normalNotification := OCMSNotification new title: 'Normal Notification';
		body: 'This is a normal notification.';
		sender: professor.
	normalNotification addReceiver: student.
	
	systemNotification := OCMSNotification new title: 'System Notification';
		body: 'This is a system notification';
		isSystemNotification: true.
	systemNotification addReceiver: student; addReceiver: professor.! !

!OCMSNoticationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 04:24'!
testHasUnreadNotificationOfUser
	notificationManager includeNotification: systemNotification.
	systemNotification readWithUser: student.
	self assert: (notificationManager hasUnreadNotificationOfUser: professor).
	self deny: (notificationManager hasUnreadNotificationOfUser: student).
	! !

!OCMSNoticationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:18'!
testIncludeNotification
	self shouldnt: [notificationManager includeNotification: normalNotification] raise: Error.
	self shouldnt: [notificationManager includeNotification: systemNotification] raise: Error.
	self should: [notificationManager includeNotification: 'notANotification'] raise: Error.! !

!OCMSNoticationManagerTest methodsFor: 'initialize-release' stamp: 'oda 5/13/2013 03:04'!
testInitialize
	self assert: notificationManager notification isEmpty.! !

!OCMSNoticationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:29'!
testReceivedNotificationOfUser
	notificationManager includeNotification: systemNotification.
	self assert: ((notificationManager receivedNotificationOfUser: student) includes: systemNotification).
	self deny: ((notificationManager receivedNotificationOfUser: student) includes: normalNotification).
	self assert: ((notificationManager receivedNotificationOfUser: professor) includes: systemNotification).! !

!OCMSNoticationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:23'!
testRemoveNotification
	notificationManager includeNotification: normalNotification.
	notificationManager includeNotification: systemNotification.
	self shouldnt: [notificationManager removeNotification: normalNotification] raise: Error.
	self should: [notificationManager removeNotification: normalNotification] raise: Error.
	self shouldnt: [notificationManager removeNotification: systemNotification] raise: Error.
	self should: [notificationManager removeNotification: 'notANotification'] raise: Error! !

!OCMSNoticationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:27'!
testSentNotificationOfUser
	notificationManager includeNotification: normalNotification.
	self assert: ((notificationManager sentNotificationOfUser: professor) includes: normalNotification).
	self deny: ((notificationManager sentNotificationOfUser: student) includes: normalNotification).
	self deny: ((notificationManager sentNotificationOfUser: professor) includes: systemNotification).! !

TestCase subclass: #OCMSNotificationTest
	instanceVariableNames: 'normalNotification systemNotification student professor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!OCMSNotificationTest methodsFor: 'setUp' stamp: 'oda 5/13/2013 03:56'!
setUp
	"Setups a normal Notification and a System notification"
	professor := User new isEnabled: true;
		name: 'Professor';
		email: 'professor@test.com';
		login: 'professor';
		password: 'professor'.
							
	student := User new name: 'Student';
		email: 'student@test.com';
		login: 'student';
		password: 'student'.
				
	normalNotification := OCMSNotification new title: 'Normal Notification';
		body: 'This is a normal notification.';
		sender: professor.
	normalNotification addReceiver: student.
	
	systemNotification := OCMSNotification new title: 'System Notification';
		body: 'This is a system notification';
		isSystemNotification: true.
	systemNotification addReceiver: student; addReceiver: professor.! !

!OCMSNotificationTest methodsFor: 'comparing' stamp: 'oda 5/13/2013 03:59'!
testEquals
	| systemNotificationCopy |
	self assert: normalNotification = normalNotification.
	self deny: normalNotification = systemNotification.
	
	systemNotificationCopy := OCMSNotification new title: (systemNotification title);
		body: (systemNotification body);
		sender: (systemNotification sender);
		isSystemNotification: (systemNotification isSystemNotification);
		dateAndTime: (systemNotification dateAndTime).
	systemNotification receiver do: [:each | systemNotificationCopy addReceiver: each].
	
	self assert: systemNotification = systemNotificationCopy.! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 04:22'!
testIsReadbyUser
	self deny: (normalNotification isReadByUser: student).
	normalNotification readWithUser: student.
	self assert: (normalNotification isReadByUser: student).! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 04:21'!
testReadWithUser
	self shouldnt: [normalNotification readWithUser: student] raise: Error.
	self should: [normalNotification readWithUser: professor] raise: Error.! !

TestCase subclass: #TagTest
	instanceVariableNames: 'tag relatedTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!TagTest commentStamp: 'HAS 4/28/2013 17:53' prior: 0!
This class contains some tests about the class Tag!

!TagTest methodsFor: 'initialize-release' stamp: 'HAS 4/29/2013 20:36'!
setUp

	tag := Tag new.! !

!TagTest methodsFor: 'testing' stamp: 'HAS 4/29/2013 20:38'!
testAsName
	
	tag name: 'Main tag'.
	self assert: tag name = 'Main tag'! !

!TagTest methodsFor: 'testing' stamp: 'HAS 4/29/2013 21:03'!
testAsRelatedTag
	
	| aOrderedTag tagTemp1 tagTemp2 |

	tagTemp1 := Tag new.
	tagTemp1 name: 'Tag 1'.
	tagTemp2 := Tag new.
	tagTemp2 name: 'Tag 2'.
	aOrderedTag := OrderedCollection new.
	aOrderedTag add: tagTemp1; add: tagTemp2.
	tag relatedTag: aOrderedTag.

	self assert: tag relatedTag size = 2.
	self assert: (tag relatedTag at:1) name = 'Tag 1'.
	self assert: (tag relatedTag at:2) name = 'Tag 2'.
	self assert: true.! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'userManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!UserManagerTest methodsFor: 'setUp' stamp: 'oda 5/1/2013 23:21'!
setUp
	userManager := UserManager new.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:38'!
testBlockUser
	| anUser |
	anUser := User new login: 'user'; isEnabled: true.
	userManager includeUser: anUser.
	self assert: (userManager userWithLogin: 'user') isEnabled.
	
	userManager blockUserWithLogin: 'user'.
	self deny: (userManager userWithLogin: 'user') isEnabled.
	! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:12'!
testIncludeUser
	self shouldnt: [
		userManager includeUserWithLogin: 'user'
					withPassword: 'test'
					withEmail: 'test@test.com'
					withName: 'User'
					isAdmin: false
		] raise: Error.
	
	self should: [
		userManager includeUserWithLogin: 'user'
					withPassword: 'test'
					withEmail: 'test@test.com'
					withName: 'User'
					isAdmin: false
		] raise: Error.
	
	self should: [
		userManager includeUserWithLogin: 'user'
					withPassword: 'test2'
					withEmail: 'test2@test2.com'
					withName: 'User2'
					isAdmin: false
		] raise: Error.! !

!UserManagerTest methodsFor: 'initialize-release' stamp: 'oda 5/1/2013 23:51'!
testInitialize
	self assert: userManager user isEmpty.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:20'!
testRemoveUser
	| user1 user2  anotherUser2 |
	user1 := User new login: 'user1'.
	user2 := User new login: 'user2'.
	anotherUser2 := User new login: 'user2'.
	
	userManager includeUser: user1.
	self shouldnt: [userManager removeUser: user1] raise: Error.
	self should: [userManager removeUser: user2] raise: Error.
	self should: [userManager removeUser: user1] raise: Error.
		
	userManager includeUser: user2.
	self shouldnt: [userManager removeUser: anotherUser2] raise: Error.
	
	userManager includeUser: user2.
	self shouldnt: [userManager removeUserWithLogin: user2 login] raise: Error.
	
! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:44'!
testUnblockUser
	| anUser |
	anUser := User new login: 'user'.
	userManager includeUser: anUser.
	self deny: (userManager userWithLogin: 'user') isEnabled.
	
	userManager unblockUserWithLogin: 'user'.
	self assert: (userManager userWithLogin: 'user') isEnabled.
	! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:45'!
testUpdateUser
	| anUser |
	anUser := User new login: 'user';
						password: 'test';
						email: 'test@test.com';
						name: 'User'.
						
	userManager includeUser: anUser.
	
	self should: [userManager updateUser: (User new login: 'dontExists')] raise: Error.
	self shouldnt: [userManager updateUserWithLogin: anUser login
								withPassword: 'anotherPassword'
								withEmail: 'anotherEmail'
								withName: 'anotherName'
								isAdmin: false
		] raise: Error.

	anUser := userManager user array at:(userManager user scanFor: (User new login: anUser login)).
	self assert: anUser password = 'anotherPassword'.
	self assert: anUser email = 'anotherEmail'.
	self assert: anUser name = 'anotherName'.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/1/2013 23:58'!
testUser
	| anUser |
	anUser := userManager includeUserWithLogin: 'user' 
							withPassword: 'test'
							withEmail: 'test@test.com'
							withName: 'User'
							isAdmin: false.
	self assert: (userManager user includes: anUser).! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/2/2013 01:07'!
testUserWithLogin
	| anUser anotherUser |
	anUser := User new login: 'user';
						password: 'test';
						email: 'test@test.com';
						name: 'User'.
	userManager includeUser: anUser.
	self should: [userManager userWithLogin: 'doesntExist'] raise: Error.
	
	self shouldnt: [anotherUser := userManager userWithLogin: anUser login] raise: Error.
	self assert: anotherUser == anUser.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:57'!
testauthenticateUserWithLogin
	| anUser |
	anUser := User new login: 'user'; password: 'password'; isEnabled: true.
	userManager includeUser: anUser.
	self assert: (userManager authenticateUserWithLogin: anUser login withPassword: anUser password).
	self deny: (userManager authenticateUserWithLogin: anUser login withPassword: 'wrongPassword').
	self should: [userManager authenticateUserWithLogin: 'UnregisteredLogin' withPassword: anUser password] raise: Error.! !

TestCase subclass: #UserTest
	instanceVariableNames: 'admin professor student'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!UserTest methodsFor: 'setUp' stamp: 'oda 5/3/2013 21:37'!
setUp
	"Setups an admin, a professor and a student"
	admin := User new isAdmin: true;
						isEnabled: true;
						name: 'Admin';
						email: 'admin@test.com';
						login: 'admin';
						password: 'admin'.
	
	professor := User new isEnabled: true;
						name: 'Professor';
						email: 'professor@test.com';
						login: 'professor';
						password: 'professor'.
							
	student := User new name: 'Student';
						email: 'student@test.com';
						login: 'student';
						password: 'student'.! !

!UserTest methodsFor: 'comparing' stamp: 'oda 5/1/2013 19:48'!
testEquals
	"Asserts deep equality."
	self assert: admin = admin.
	self assert: admin = (User new login: (admin login)).
	self deny: admin = student.
	self deny: student = professor.! !

!UserTest methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:40'!
testIncludeOrUpdateCourse
	"Tests consistency upon including a user role within a course"
	| aCourse |
	aCourse := Course new.
	
	self should: [student includeOrUpdateCourse: aCourse withRole: 'anything'] raise: Error.
	self should: [student includeOrUpdateCourse: 'anything' withRole: UserType student] raise: Error.
	
	self shouldnt: [student includeOrUpdateCourse: aCourse withRole: UserType student] raise: Error.
	self assert: (student course includes: aCourse).
	self shouldnt: [professor includeOrUpdateCourse: aCourse withRole: UserType professor] raise: Error.
	self shouldnt: [professor includeOrUpdateCourse: aCourse withRole: UserType student] raise: Error.! !

!UserTest methodsFor: 'initialize-release' stamp: 'oda 5/3/2013 21:37'!
testInitialize
	"Asserts initialization after instance creation"
	self assert: admin isAdmin.
	self assert: admin isEnabled.
	self assert: admin course isEmpty.
	
	self deny: professor isAdmin.
	self assert: professor isEnabled.
	self assert: professor course isEmpty.

	self deny: student isAdmin.
	self deny: student isEnabled.
	self assert: student course isEmpty.
! !

!UserTest methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:40'!
testRoleAtCourse
	"Tests accessing an user role within a course"
	| aCourse anotherCourse |
	aCourse := Course new.
	anotherCourse := Course new.
	
	student includeOrUpdateCourse: aCourse withRole: UserType student.
	self shouldnt: [student roleAtCourse: aCourse] raise: Error.
	self assert: (student roleAtCourse: aCourse) = UserType student.
	
	self should: [student roleAtCourse: 'aCourse'] raise: Error.
	self should: [student roleAtCourse: anotherCourse] raise: Error. 
	
	! !

TestCase subclass: #UserTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!UserTypeTest methodsFor: 'instance creation' stamp: 'oda 5/1/2013 18:31'!
testNew
	self should: [UserType new] raise: Error.! !

!UserTypeTest methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:18'!
testProfessor
	self assert: (UserType UserTypeList includes: UserType professor).! !

!UserTypeTest methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:18'!
testStudent
	self assert: (UserType UserTypeList includes: UserType student).! !
